package com.ssm.controller;


import javax.persistence.Column;
import javax.persistence.Id;

import com.github.pagehelper.PageInfo;
import com.ssm.manage.entity.StaffLevels;
import com.ssm.manage.dto.StaffLevelsDto;
import com.ssm.manage.response.GenericResponse;
import com.ssm.manage.response.PageResponse;
import com.ssm.manage.response.ResponseCode;
import com.ssm.manage.service.StaffLevelsService;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;

import java.io.Serializable;

import lombok.extern.slf4j.Slf4j;
import com.ssm.core.utils.SnowflakeUtil;

import java.util.Random;

/**
 * (StaffLevels)表控制层
 *
 * @author makejava
 * @since 2024-01-12 09:47:47
 */
@RestController
@RequestMapping("staffLevels")
@Slf4j
@Api(tags = "")
public class StaffLevelsController {
    /**
     * 服务对象
     */
    @Autowired
    private StaffLevelsService staffLevelsService;

/**
 * 通过主键查询单条数据
 *
 * @param id 主键
 * @return
 @GetMapping("{id}")
 @ApiOperation("通过主键查询单条数据")
 //@RequiresPermissions("system:staffLevels:query")
 public ResultVo get(@PathVariable Serializable id) {
 return this.staffLevelsService.queryById(id);
 }
 */


    /**
     * 分页查询
     *
     * @param dto
     * @return
     */
    @GetMapping
    @ApiOperation("分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页码", defaultValue = "1", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页数量", defaultValue = "10", required = true)
    })
//@RequiresPermissions("system:staffLevels:query")
    public PageResponse<StaffLevels> listPage(StaffLevelsDto dto) {
        PageResponse<StaffLevels> pageResponse = new PageResponse<>();
        PageInfo<StaffLevels> pageInfo = new PageInfo<>();
        try {
            pageInfo = this.staffLevelsService.selectPage(dto);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.selectPage", e);
            pageResponse.setCodeAndMsg(ResponseCode.FAILED);
            return pageResponse;
        }
        pageResponse.setPageInfo(pageInfo);
        pageResponse.setCodeAndMsg(ResponseCode.OK);
        return pageResponse;
    }

    /**
     * 新增
     *
     * @param staffLevels
     * @return
     */
    @PostMapping
    @ApiOperation("新增")
//@RequiresPermissions("system:staffLevels:add")
    public GenericResponse add(@RequestBody StaffLevels staffLevels) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
//            staffLevels.setId(new SnowflakeUtil(new Random().nextInt(1023)).nextId());
            i = this.staffLevelsService.save(staffLevels);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 编辑
     *
     * @param staffLevels
     * @return
     */
    @PutMapping
    @ApiOperation("编辑")
//@RequiresPermissions("system:staffLevels:edit")
    public GenericResponse edit(@RequestBody StaffLevels staffLevels) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            i = this.staffLevelsService.updateByPrimaryKey(staffLevels);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 根据主键删除
     *
     * @param id 主键
     * @return
     */
    @DeleteMapping("{id}")
    @ApiOperation("根据主键删除")
//@RequiresPermissions("system:staffLevels:delete")
    public GenericResponse delete(@PathVariable Integer id) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            StaffLevels staffLevels = new StaffLevels();
            staffLevels.setId(id);
            i = this.staffLevelsService.delete(staffLevels);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

}
